#include "D3DApp.h"

D3DApp::D3DApp(void)
{
}

D3DApp::~D3DApp(void)
{
}

HRESULT D3DApp::InitD3D(HWND hWnd)
{
     hWnd = hWnd;
 
     if( NULL == ( pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;
    
    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof( d3dpp ) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
 	//ZBuffer Setting
	//d3dpp.EnableAutoDepthStencil = TRUE;
	//d3dpp.AutoDepthStencilFormat = D3DFMT_D24S8;

    if( FAILED( pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL,
                                  hWnd,  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                      &d3dpp, &pd3dDevice ) ) )
		return E_FAIL;
 
	//pd3dDevice->SetRenderState(D3DRS_ZENABLE, TRUE);

	OnInit();

    return S_OK;
}

void D3DApp::Render()
{
	if( NULL == pd3dDevice )
		return;
 
    // Clear the backbuffer
	 pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET , D3DCOLOR_XRGB( 0, 0, 255), 1.0f, 0 );
 
    // Begin the scene
	if( SUCCEEDED( pd3dDevice->BeginScene() ) )
	{
		OnRender();
 
        // End the scene
		pd3dDevice->EndScene();
	}
 
	// Present the backbuffer contents to the display
	pd3dDevice->Present( NULL, NULL, NULL, NULL );
}

void D3DApp::Update()
{
	OnUpdate();
}

void D3DApp::Cleanup()
{
	OnRelease();

	if( pd3dDevice != NULL )
		pd3dDevice->Release();
 
	if( pD3D != NULL )
		pD3D->Release();
}